=== tensorflow/compiler/xla/mlir_hlo/analysis/CMakeLists.txt ===
add_mlir_library(MLIRHLOAnalysis
  userange_analysis.cc

  DEPENDS
  mlir-headers

  LINK_LIBS PUBLIC
  MLIRAnalysis
  MLIRIR
)

add_mlir_library(MLIRHLOTestAnalysis
  test_userange_analysis.cc

  DEPENDS
  LMHLOTransformsPassIncGen

  LINK_COMPONENTS
  Core

  LINK_LIBS PUBLIC
  LmhloDialect
  LmhloGPUDialect
  MLIRHLOAnalysis
  MLIRAnalysis
  MLIRPass
  MLIRTransforms
)
