=== debian/changelog ===
tensorflow (2.14.1+dfsg-3) unstable; urgency=medium

  * Add autopkgtest building a simple application using TensorFlow Lite
    and then executing it on a mobilenet model.

 -- Dylan Aïssi <daissi@debian.org>  Sun, 07 Sep 2025 20:52:13 +0200

tensorflow (2.14.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 01 Sep 2025 21:38:37 +0200

tensorflow (2.14.1+dfsg-1) experimental; urgency=medium

  * New upstream version 2.14.1
      (Closes: #1084624)
  * Drop all packaging parts requiring bazel since this work is stuck for now.
    With the approval of Mo Zhou and Andreas Tille!
      (Closes: #1005713)
  * Build tensorflow-lite which doesn't require bazel but can be built with
    cmake.
  * Update debian/copyright.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 01 Sep 2025 11:10:22 +0200
