=== debian/tests/control ===
Tests: tflite-minimal-example
Depends: libtensorflow-lite-dev, libffi-dev, build-essential, cmake, wget
Restrictions: superficial, needs-internet
